## haxe 4.0.5

=== Makefile ===
# Haxe compiler Makefile
#
#  - use 'make' to build all
#  - use 'make haxe' to build only the compiler (not the libraries)
#  - if you want to build quickly, install 'ocamlopt.opt' and change OCAMLOPT=ocamlopt.opt
#
#  Windows users :
#  - use 'make -f Makefile.win' to build for Windows
#  - use 'make MSVC=1 -f Makefile.win' to build for Windows with OCaml/MSVC
#
.SUFFIXES : .ml .mli .cmo .cmi .cmx .mly

INSTALL_DIR=/usr/local
INSTALL_BIN_DIR=$(INSTALL_DIR)/bin
INSTALL_LIB_DIR=$(INSTALL_DIR)/lib/haxe
INSTALL_STD_DIR=$(INSTALL_DIR)/share/haxe/std
PACKAGE_OUT_DIR=out
INSTALLER_TMP_DIR=installer
PACKAGE_SRC_EXTENSION=.tar.gz

MAKEFILENAME?=Makefile
PLATFORM?=unix

HAXE_OUTPUT=haxe
HAXELIB_OUTPUT=haxelib
PREBUILD_OUTPUT=prebuild
EXTENSION=
LFLAGS=
STATICLINK?=0

# Configuration

# Modules in these directories should only depend on modules that are in directories to the left
HAXE_DIRECTORIES=core core/json core/display syntax context context/display codegen codegen/gencommon generators generators/jvm optimization filters macro macro/eval macro/eval/bytes typing compiler
EXTLIB_LIBS=extlib-leftovers extc neko javalib swflib ttflib ilib objsize pcre ziplib
OCAML_LIBS=unix str threads dynlink
OPAM_LIBS=sedlex.ppx xml-light extlib ptmap sha

FINDLIB_LIBS=$(OCAML_LIBS)
FINDLIB_LIBS+=$(OPAM_LIBS)

# Includes, packages and compiler

HAXE_INCLUDES=$(HAXE_DIRECTORIES:%=-I _build/src/%)
EXTLIB_INCLUDES=$(EXTLIB_LIBS:%=-I libs/%)
ALL_INCLUDES=$(EXTLIB_INCLUDES) $(HAXE_INCLUDES)
FINDLIB_PACKAGES=$(FINDLIB_LIBS:%=-package %)
CFLAGS=
ALL_CFLAGS=-bin-annot -safe-string -thread -g -w -3 -w -40 $(CFLAGS) $(ALL_INCLUDES) $(FINDLIB_PACKAGES)

MESSAGE_FILTER=sed -e 's/_build\/src\//src\//' tmp.tmp

ifeq ($(BYTECODE),1)
	TARGET_FLAG = bytecode
	COMPILER = ocamlfind ocamlc
	LIB_EXT = cma
	MODULE_EXT = cmo
	NATIVE_LIB_FLAG = -custom
else
	TARGET_FLAG = native
	COMPILER = ocamlfind ocamlopt
	LIB_EXT = cmxa
	MODULE_EXT = cmx
	OCAMLDEP_FLAGS = -native
endif

CC_CMD = ($(COMPILER) $(ALL_CFLAGS) -c $< 2>tmp.tmp && $(MESSAGE_FILTER)) || ($(MESSAGE_FILTER) && exit 1)

# Meta information

BUILD_DIRECTORIES := $(HAXE_DIRECTORIES:%=_build/src/%)
HAXE_SRC := $(wildcard $(HAXE_DIRECTORIES:%=src/%/*.ml))
BUILD_SRC := $(HAXE_SRC:%=_build/%)

ADD_REVISION?=0

BRANCH=$(shell echo $$APPVEYOR_REPO_NAME | grep -q /haxe && echo $$APPVEYOR_REPO_BRANCH || echo $$TRAVIS_REPO_SLUG | grep -q /haxe && echo $$TRAVIS_BRANCH || git rev-parse --abbrev-ref HEAD)
COMMIT_SHA=$(shell git rev-parse --short HEAD)
COMMIT_DATE=$(shell \
	if [ "$$(uname)" = "Darwin" ]; then \
		date -u -r $$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	else \
		date -u -d @$$(git show -s --format=%ct HEAD) +%Y%m%d%H%M%S; \
	fi \
)
PACKAGE_FILE_NAME=haxe_$(COMMIT_DATE)_$(COMMIT_SHA)
HAXE_VERSION=$(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1 | awk '{print $$1;}')
HAXE_VERSION_SHORT=$(shell echo "$(HAXE_VERSION)" | grep -oE "^[0-9]+\.[0-9]+\.[0-9]+")

# using $(CURDIR) on Windows will not work since it might be a Cygwin path
ifdef SYSTEMROOT
	EXTENSION=.exe
else
	export HAXE_STD_PATH=$(CURDIR)/std
endif

# Native libraries

ifneq ($(STATICLINK),0)
	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre -lz -Wl,-Bdynamic '
else
	LIB_PARAMS?= -cclib -lpcre -cclib -lz
endif

NATIVE_LIBS=-thread -cclib libs/extc/extc_stubs.o -cclib libs/extc/process_stubs.o -cclib libs/objsize/c_objsize.o -cclib libs/pcre/pcre_stubs.o -ccopt -L/usr/local/lib $(LIB_PARAMS)

# Modules

-include Makefile.modules

# Rules

all: libs haxe tools

libs:
	$(foreach lib,$(EXTLIB_LIBS),$(MAKE) -C libs/$(lib) $(TARGET_FLAG) &&) true

_build/%:%
	mkdir -p $(dir $@)
	cp $< $@

build_dirs:
	@mkdir -p $(BUILD_DIRECTORIES)

_build/src/syntax/grammar.ml:src/syntax/grammar.mly
	camlp5o -impl $< -o $@

_build/src/compiler/version.ml: FORCE
ifneq ($(ADD_REVISION),0)
	$(MAKE) -f Makefile.version_extra -s --no-print-directory ADD_REVISION=$(ADD_REVISION) BRANCH=$(BRANCH) COMMIT_SHA=$(COMMIT_SHA) COMMIT_DATE=$(COMMIT_DATE) > _build/src/compiler/version.ml
else
	echo let version_extra = None > _build/src/compiler/version.ml
endif

_build/src/core/defineList.ml: src-json/define.json prebuild
	./$(PREBUILD_OUTPUT) define $< > $@

_build/src/core/metaList.ml: src-json/meta.json prebuild
	./$(PREBUILD_OUTPUT) meta $< > $@

build_src: | $(BUILD_SRC) _build/src/syntax/grammar.ml _build/src/compiler/version.ml _build/src/core/defineList.ml _build/src/core/metaList.ml

prebuild: _build/src/core/json/json.ml _build/src/prebuild/main.ml
	$(COMPILER) -safe-string -linkpkg -g -o $(PREBUILD_OUTPUT) -package sedlex.ppx -package extlib -I _build/src/core/json _build/src/core/json/json.ml _build/src/prebuild/main.ml

haxe: build_src
	$(MAKE) -f $(MAKEFILENAME) build_pass_1
	$(MAKE) -f $(MAKEFILENAME) build_pass_2
	$(MAKE) -f $(MAKEFILENAME) build_pass_3
	$(MAKE) -f $(MAKEFILENAME) build_pass_4

build_pass_1:
	printf MODULES= > Makefile.modules
	ls -1 $(HAXE_DIRECTORIES:%=_build/src/%/*.ml) | tr '\n' ' ' >> Makefile.modules

build_pass_2:
	printf MODULES= > Makefile.modules
	ocamlfind ocamldep -sort -slash $(HAXE_INCLUDES) $(MODULES) | sed -e "s/\.ml//g" >> Makefile.modules

build_pass_3:
	ocamlfind ocamldep -slash $(OCAMLDEP_FLAGS) $(HAXE_INCLUDES) $(MODULES:%=%.ml) > Makefile.dependencies

build_pass_4: $(MODULES:%=%.$(MODULE_EXT))
	$(COMPILER) -safe-string -linkpkg -g -o $(HAXE_OUTPUT) $(NATIVE_LIBS) $(NATIVE_LIB_FLAG) $(LFLAGS) $(FINDLIB_PACKAGES) $(EXTLIB_INCLUDES) $(EXTLIB_LIBS:=.$(LIB_EXT)) $(MODULES:%=%.$(MODULE_EXT))

kill_exe_win:
ifdef SYSTEMROOT
	-@taskkill /F /IM haxe.exe 2>/dev/null
endif

plugin:
ifeq ($(BYTECODE),1)
	$(CC_CMD) $(PLUGIN).ml
else
	$(COMPILER) $(ALL_CFLAGS) -shared -o $(PLUGIN).cmxs $(PLUGIN).ml
endif

# Only use if you have only changed gencpp.ml
quickcpp: build_src build_pass_4 copy_haxetoolkit

CPP_OS := $(shell uname)
ifeq ($(CPP_OS),Linux)
copy_haxetoolkit:
	sudo cp haxe /usr/bin/haxe
else
copy_haxetoolkit: /cygdrive/c/HaxeToolkit/haxe/haxe.exe
/cygdrive/c/HaxeToolkit/haxe/haxe.exe:haxe.exe
	cp $< $@
endif

haxelib:
	(cd $(CURDIR)/extra/haxelib_src && $(CURDIR)/$(HAXE_OUTPUT) client.hxml && nekotools boot run.n)
	mv extra/haxelib_src/run$(EXTENSION) $(HAXELIB_OUTPUT)

tools: haxelib

install: uninstall
	mkdir -p "$(DESTDIR)$(INSTALL_BIN_DIR)"
	cp $(HAXE_OUTPUT) $(HAXELIB_OUTPUT) "$(DESTDIR)$(INSTALL_BIN_DIR)"
	mkdir -p "$(DESTDIR)$(INSTALL_STD_DIR)"
	cp -r std/* "$(DESTDIR)$(INSTALL_STD_DIR)"

uninstall:
	rm -rf $(DESTDIR)$(INSTALL_BIN_DIR)/$(HAXE_OUTPUT) $(DESTDIR)$(INSTALL_BIN_DIR)/$(HAXELIB_OUTPUT)
	if [ -d "$(DESTDIR)$(INSTALL_LIB_DIR)/lib" ] && find "$(DESTDIR)$(INSTALL_LIB_DIR)/lib" -mindepth 1 -print -quit | grep -q .; then \
		echo "The local haxelib repo at $(DESTDIR)$(INSTALL_LIB_DIR)/lib will not be removed. Remove it manually if you want."; \
		find $(DESTDIR)$(INSTALL_LIB_DIR)/ ! -name 'lib' -mindepth 1 -maxdepth 1 -exec rm -rf {} +; \
	else \
		rm -rf $(DESTDIR)$(INSTALL_LIB_DIR); \
	fi
	rm -rf $(DESTDIR)$(INSTALL_STD_DIR)

opam_install:
	opam install $(OPAM_LIBS) camlp5 ocamlfind --yes

# Dependencies

-include Makefile.dependencies

# Package

package_src:
	mkdir -p $(PACKAGE_OUT_DIR)
	# use git-archive-all since we have submodules
	# https://github.com/Kentzo/git-archive-all
	curl -s https://raw.githubusercontent.com/Kentzo/git-archive-all/1.15/git_archive_all.py -o extra/git_archive_all.py
	python extra/git_archive_all.py $(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_src$(PACKAGE_SRC_EXTENSION)

package_unix:
	mkdir -p $(PACKAGE_OUT_DIR)
	rm -rf $(PACKAGE_FILE_NAME) $(PACKAGE_FILE_NAME).tar.gz
	# Copy the package contents to $(PACKAGE_FILE_NAME)
	mkdir -p $(PACKAGE_FILE_NAME)
	cp -r $(HAXE_OUTPUT) $(HAXELIB_OUTPUT) std extra/LICENSE.txt extra/CONTRIB.txt extra/CHANGES.txt $(PACKAGE_FILE_NAME)
	# archive
	tar -zcf $(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz $(PACKAGE_FILE_NAME)
	rm -r $(PACKAGE_FILE_NAME)

package_bin: package_$(PLATFORM)

xmldoc:
	cd extra && \
	$(CURDIR)/$(HAXELIB_OUTPUT) newrepo && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxcpp  https://github.com/HaxeFoundation/hxcpp   && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxjava https://github.com/HaxeFoundation/hxjava  && \
	$(CURDIR)/$(HAXELIB_OUTPUT) git hxcs   https://github.com/HaxeFoundation/hxcs    && \
	PATH="$(CURDIR):$(PATH)" $(CURDIR)/$(HAXE_OUTPUT) doc.hxml

$(INSTALLER_TMP_DIR):
	mkdir -p $(INSTALLER_TMP_DIR)

$(INSTALLER_TMP_DIR)/neko-osx64.tar.gz: $(INSTALLER_TMP_DIR)
	wget -nv https://github.com/HaxeFoundation/neko/releases/download/v2-3-0/neko-2.3.0-osx64.tar.gz -O installer/neko-osx64.tar.gz

# Installer

package_installer_mac: $(INSTALLER_TMP_DIR)/neko-osx64.tar.gz package_unix
	$(eval OUTFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_installer.tar.gz)
	$(eval PACKFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz)
	$(eval VERSION := $(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1))
	$(eval NEKOVER := $(shell neko -version 2>&1))
	bash -c "rm -rf $(INSTALLER_TMP_DIR)/{resources,pkg,tgz,haxe.tar.gz}"
	mkdir $(INSTALLER_TMP_DIR)/resources
	# neko - unpack to change the dir name
	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf ../neko-osx64.tar.gz
	mv $(INSTALLER_TMP_DIR)/resources/neko* $(INSTALLER_TMP_DIR)/resources/neko
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf neko.tar.gz neko
	# haxe - unpack to change the dir name
	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf $(PACKFILE)
	mv $(INSTALLER_TMP_DIR)/resources/haxe* $(INSTALLER_TMP_DIR)/resources/haxe
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf haxe.tar.gz haxe
	# scripts
	cp -rf extra/mac-installer/* $(INSTALLER_TMP_DIR)/resources
	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf scripts.tar.gz scripts
	# installer structure
	mkdir -p $(INSTALLER_TMP_DIR)/pkg
	cd $(INSTALLER_TMP_DIR)/pkg && xar -xf ../resources/installer-structure.pkg .
	mkdir $(INSTALLER_TMP_DIR)/tgz; mv $(INSTALLER_TMP_DIR)/resources/*.tar.gz $(INSTALLER_TMP_DIR)/tgz
	cd $(INSTALLER_TMP_DIR)/tgz; find . | cpio -o --format odc | gzip -c > ../pkg/files.pkg/Payload
	cd $(INSTALLER_TMP_DIR)/pkg/files.pkg && bash -c "INSTKB=$$(du -sk ../../tgz | awk '{print $$1;}'); \
	du -sk ../../tgz; \
	echo $$INSTKB ; \
	INSTKBH=`expr $$INSTKB - 4`; \
	echo $$INSTKBH ;\
	sed -i '' 's/%%INSTKB%%/$$INSTKBH/g' PackageInfo ;\
	sed -i '' 's/%%VERSION%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' PackageInfo ;\
	sed -i '' 's/%%NEKOVER%%/$(NEKOVER)/g' PackageInfo ;\
	cd .. ;\
	sed -i '' 's/%%VERSION%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' Distribution ;\
	sed -i '' 's/%%NEKOVER%%/$(NEKOVER)/g' Distribution ;\
	sed -i '' 's/%%INSTKB%%/$$INSTKBH/g' Distribution"
	# repackage
	cd $(INSTALLER_TMP_DIR)/pkg; xar --compression none -cf ../$(PACKAGE_FILE_NAME).pkg *
	# tar
	cd $(INSTALLER_TMP_DIR); tar -zcvf $(OUTFILE) $(PACKAGE_FILE_NAME).pkg

# Clean

clean: clean_libs clean_haxe clean_tools clean_package

clean_libs:
	$(foreach lib,$(EXTLIB_LIBS),$(MAKE) -C libs/$(lib) clean &&) true

clean_haxe:
	rm -f -r _build $(HAXE_OUTPUT) $(PREBUILD_OUTPUT)

clean_tools:
	rm -f $(HAXE_OUTPUT) $(PREBUILD_OUTPUT) $(HAXELIB_OUTPUT)

clean_package:
	rm -rf $(PACKAGE_OUT_DIR)

FORCE:

# SUFFIXES

.ml.cmx:
	$(CC_CMD)

.ml.cmo:
	$(CC_CMD)

.PHONY: haxe libs haxelib

=== libs/extlib-leftovers/Makefile ===
# Makefile contributed by Alain Frisch
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

MODULES = \
 multiArray rbuffer uCharExt uTF8

# the list is topologically sorted

MLI = $(MODULES:=.mli)
SRC = $(MLI) $(MODULES:=.ml)

all: bytecode native

opt: native

bytecode: extlib-leftovers.cma

native: extlib-leftovers.cmxa

extlib-leftovers.cma: $(SRC)
	$(OCAMLC) -safe-string -a -o extlib-leftovers.cma $(SRC)

extlib-leftovers.cmxa: $(SRC)
	$(OCAMLOPT) -safe-string -g -a -o extlib-leftovers.cmxa $(SRC)

clean:
	rm -f $(wildcard *.cmo) $(wildcard *.cmx) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.a) $(wildcard *.lib) $(wildcard *.obj)
	rm -Rf doc

.PHONY: all opt bytecode native doc copy install uninstall clean

Makefile: ;

$(SRC): ;

=== debian/changelog ===
haxe (1:4.0.5-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Wed, 18 Dec 2019 03:29:59 +0800

haxe (1:4.0.3-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Fri, 29 Nov 2019 23:31:54 +0800

=== debian/control ===
Source: haxe
Section: devel
Priority: optional
Maintainer: Andy Li <andy@onthewings.net>
Standards-Version: 4.4.1
Build-Depends: debhelper (>= 9),
               dh-ocaml,
               ocaml-nox,
               ocaml-findlib,
               camlp5,
               libxml-light-ocaml-dev,
               libsedlex-ocaml-dev (>= 2.0),
               libextlib-ocaml-dev,
               libptmap-ocaml-dev,
               libsha-ocaml-dev,
               neko (>= 2.3.0),
               zlib1g-dev,
               libpcre3-dev,
               bash-completion
Vcs-Git: https://github.com/HaxeFoundation/haxe-debian.git
Vcs-Browser: https://github.com/HaxeFoundation/haxe-debian
Homepage: https://haxe.org

Package: haxe
Architecture: any
Depends: neko (>= 2.0.0),
         ${misc:Depends},
         ${ocaml:Depends},
         ${shlibs:Depends}
Description: multi-target universal programming language
 Haxe is an open source toolkit based on a modern,
 high level, strictly typed programming language, a cross-compiler,
 a complete cross-platform standard library and ways to access each
 platform's native capabilities.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Haxe.

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/dpkg/pkg-info.mk

# bytecompile everything if ocamlopt doesn't exists
ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
	BYTECODE = "BYTECODE=1"
endif

%:
	dh $@ --with ocaml,bash-completion

override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_build -- $(BYTECODE)
	# Compile haxelib to neko
	dh_auto_build -- tools

override_dh_auto_install:

override_dh_strip:
	# haxelib is the neko vm appended with neko bytecode. It should not be stripped
	dh_strip --exclude=haxelib

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	# create tar manually from git, in order to get submodules
	git clone --branch $(DEB_VERSION_UPSTREAM) --depth 1 --recursive https://github.com/HaxeFoundation/haxe.git orig-source
	cd orig-source && \
		python $(CURDIR)/debian/git-archive-all ../../haxe_$(DEB_VERSION_UPSTREAM).orig.tar.gz
	rm -rf orig-source

## haxe 4.1.0

=== debian/changelog ===
haxe (1:4.1.0-1) unstable; urgency=medium

  * New upstream version.
  * Add version.ml.diff patch to avoid usage of git during build.
  * Update d/rules.
  * Bump debhelper compat to 10.

 -- Andy Li <andy@onthewings.net>  Thu, 21 May 2020 09:57:13 +0800

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,18 @@
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
 Standards-Version: 4.4.1
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                dh-ocaml,
                ocaml-nox,
                ocaml-findlib,
+               ocaml-dune,
                camlp5,
                libxml-light-ocaml-dev,
                libsedlex-ocaml-dev (>= 2.0),
                libextlib-ocaml-dev,
                libptmap-ocaml-dev,
                libsha-ocaml-dev,
+               libmbedtls-dev,
                neko (>= 2.3.0),
                zlib1g-dev,
                libpcre3-dev,

## haxe 4.1.1

=== debian/changelog ===
haxe (1:4.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Remove version.ml.diff patch, which was integrated in this
    version already.
  * Bump Standards-Version to 4.5.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 25 May 2020 11:43:10 +0800

## haxe 4.1.2

=== debian/changelog ===
haxe (1:4.1.2-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sat, 20 Jun 2020 12:57:44 +0800

## haxe 4.1.3

=== debian/changelog ===
haxe (1:4.1.3-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Thu, 23 Jul 2020 21:47:29 +0800

## haxe 4.1.4

=== debian/changelog ===
haxe (1:4.1.4-1) UNRELEASED; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sun, 20 Sep 2020 23:24:55 +0800

## haxe 4.1.5

=== Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
 MAKEFILENAME?=Makefile
 PLATFORM?=unix
 
+DUNE_COMMAND=dune
 HAXE_OUTPUT=haxe
 HAXELIB_OUTPUT=haxelib
 PREBUILD_OUTPUT=prebuild
@@ -28,49 +29,20 @@
 LFLAGS=
 STATICLINK?=0
 
+SYSTEM_NAME=Unknown
+ifeq ($(OS),Windows_NT)
+	SYSTEM_NAME=Windows
+else
+	UNAME_S := $(shell uname -s)
+	ifeq ($(UNAME_S),Linux)
+		SYSTEM_NAME=Linux
+	endif
+	ifeq ($(UNAME_S),Darwin)
+		SYSTEM_NAME=Mac
+	endif
+endif
+
 # Configuration
-
-# Modules in these directories should only depend on modules that are in directories to the left
-HAXE_DIRECTORIES=core core/json core/display syntax context context/display codegen codegen/gencommon generators generators/jvm optimization filters macro macro/eval macro/eval/bytes typing compiler
-EXTLIB_LIBS=extlib-leftovers extc neko javalib swflib ttflib ilib objsize pcre ziplib
-OCAML_LIBS=unix str threads dynlink
-OPAM_LIBS=sedlex.ppx xml-light extlib ptmap sha
-
-FINDLIB_LIBS=$(OCAML_LIBS)
-FINDLIB_LIBS+=$(OPAM_LIBS)
-
-# Includes, packages and compiler
-
-HAXE_INCLUDES=$(HAXE_DIRECTORIES:%=-I _build/src/%)
-EXTLIB_INCLUDES=$(EXTLIB_LIBS:%=-I libs/%)
-ALL_INCLUDES=$(EXTLIB_INCLUDES) $(HAXE_INCLUDES)
-FINDLIB_PACKAGES=$(FINDLIB_LIBS:%=-package %)
-CFLAGS=
-ALL_CFLAGS=-bin-annot -safe-string -thread -g -w -3 -w -40 $(CFLAGS) $(ALL_INCLUDES) $(FINDLIB_PACKAGES)
-
-MESSAGE_FILTER=sed -e 's/_build\/src\//src\//' tmp.tmp
-
-ifeq ($(BYTECODE),1)
-	TARGET_FLAG = bytecode
-	COMPILER = ocamlfind ocamlc
-	LIB_EXT = cma
-	MODULE_EXT = cmo
-	NATIVE_LIB_FLAG = -custom
-else
-	TARGET_FLAG = native
-	COMPILER = ocamlfind ocamlopt
-	LIB_EXT = cmxa
-	MODULE_EXT = cmx
-	OCAMLDEP_FLAGS = -native
-endif
-
-CC_CMD = ($(COMPILER) $(ALL_CFLAGS) -c $< 2>tmp.tmp && $(MESSAGE_FILTER)) || ($(MESSAGE_FILTER) && exit 1)
-
-# Meta information
-
-BUILD_DIRECTORIES := $(HAXE_DIRECTORIES:%=_build/src/%)
-HAXE_SRC := $(wildcard $(HAXE_DIRECTORIES:%=src/%/*.ml))
-BUILD_SRC := $(HAXE_SRC:%=_build/%)
 
 ADD_REVISION?=0
 
@@ -87,92 +59,32 @@
 HAXE_VERSION=$(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1 | awk '{print $$1;}')
 HAXE_VERSION_SHORT=$(shell echo "$(HAXE_VERSION)" | grep -oE "^[0-9]+\.[0-9]+\.[0-9]+")
 
-# using $(CURDIR) on Windows will not work since it might be a Cygwin path
-ifdef SYSTEMROOT
-	EXTENSION=.exe
+ifneq ($(STATICLINK),0)
+	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre -lz -lmbedtls -lmbedx509 -lmbedcrypto -Wl,-Bdynamic '
 else
-	export HAXE_STD_PATH=$(CURDIR)/std
-endif
-
-# Native libraries
-
-ifneq ($(STATICLINK),0)
-	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre -lz -Wl,-Bdynamic '
-else
-	LIB_PARAMS?= -cclib -lpcre -cclib -lz
-endif
-
-NATIVE_LIBS=-thread -cclib libs/extc/extc_stubs.o -cclib libs/extc/process_stubs.o -cclib libs/objsize/c_objsize.o -cclib libs/pcre/pcre_stubs.o -ccopt -L/usr/local/lib $(LIB_PARAMS)
-
-# Modules
-
--include Makefile.modules
-
-# Rules
-
-all: libs haxe tools
-
-libs:
-	$(foreach lib,$(EXTLIB_LIBS),$(MAKE) -C libs/$(lib) $(TARGET_FLAG) &&) true
-
-_build/%:%
-	mkdir -p $(dir $@)
-	cp $< $@
-
-build_dirs:
-	@mkdir -p $(BUILD_DIRECTORIES)
-
-_build/src/syntax/grammar.ml:src/syntax/grammar.mly
-	camlp5o -impl $< -o $@
-
-_build/src/compiler/version.ml: FORCE
-ifneq ($(ADD_REVISION),0)
-	$(MAKE) -f Makefile.version_extra -s --no-print-directory ADD_REVISION=$(ADD_REVISION) BRANCH=$(BRANCH) COMMIT_SHA=$(COMMIT_SHA) COMMIT_DATE=$(COMMIT_DATE) > _build/src/compiler/version.ml
-else
-	echo let version_extra = None > _build/src/compiler/version.ml
-endif
-
-_build/src/core/defineList.ml: src-json/define.json prebuild
-	./$(PREBUILD_OUTPUT) define $< > $@
-
-_build/src/core/metaList.ml: src-json/meta.json prebuild
-	./$(PREBUILD_OUTPUT) meta $< > $@
-
-build_src: | $(BUILD_SRC) _build/src/syntax/grammar.ml _build/src/compiler/version.ml _build/src/core/defineList.ml _build/src/core/metaList.ml
-
-prebuild: _build/src/core/json/json.ml _build/src/prebuild/main.ml
-	$(COMPILER) -safe-string -linkpkg -g -o $(PREBUILD_OUTPUT) -package sedlex.ppx -package extlib -I _build/src/core/json _build/src/core/json/json.ml _build/src/prebuild/main.ml
-
-haxe: build_src
-	$(MAKE) -f $(MAKEFILENAME) build_pass_1
-	$(MAKE) -f $(MAKEFILENAME) build_pass_2
-	$(MAKE) -f $(MAKEFILENAME) build_pass_3
-	$(MAKE) -f $(MAKEFILENAME) build_pass_4
-
-build_pass_1:
-	printf MODULES= > Makefile.modules
-	ls -1 $(HAXE_DIRECTORIES:%=_build/src/%/*.ml) | tr '\n' ' ' >> Makefile.modules
-
-build_pass_2:
-	printf MODULES= > Makefile.modules
-	ocamlfind ocamldep -sort -slash $(HAXE_INCLUDES) $(MODULES) | sed -e "s/\.ml//g" >> Makefile.modules
-
-build_pass_3:
-	ocamlfind ocamldep -slash $(OCAMLDEP_FLAGS) $(HAXE_INCLUDES) $(MODULES:%=%.ml) > Makefile.dependencies
-
-build_pass_4: $(MODULES:%=%.$(MODULE_EXT))
-	$(COMPILER) -safe-string -linkpkg -g -o $(HAXE_OUTPUT) $(NATIVE_LIBS) $(NATIVE_LIB_FLAG) $(LFLAGS) $(FINDLIB_PACKAGES) $(EXTLIB_INCLUDES) $(EXTLIB_LIBS:=.$(LIB_EXT)) $(MODULES:%=%.$(MODULE_EXT))
+	LIB_PARAMS?= -cclib -lpcre -cclib -lz -cclib -lmbedtls -cclib -lmbedx509 -cclib -lmbedcrypto
+endif
+ifeq ($(SYSTEM_NAME),Mac)
+	LIB_PARAMS+= -cclib '-framework Security -framework CoreFoundation'
+endif
+
+all: haxe tools
+
+haxe:
+	$(DUNE_COMMAND) build --workspace dune-workspace.dev src-prebuild/prebuild.exe
+	_build/default/src-prebuild/prebuild.exe libparams $(LIB_PARAMS) > lib.sexp
+	_build/default/src-prebuild/prebuild.exe version "$(ADD_REVISION)" "$(BRANCH)" "$(COMMIT_SHA)" > src/compiler/version.ml
+	$(DUNE_COMMAND) build --workspace dune-workspace.dev src/haxe.exe
+	cp -f _build/default/src/haxe.exe ./"$(HAXE_OUTPUT)"
+
+plugin: haxe
+	$(DUNE_COMMAND) build --workspace dune-workspace.dev plugins/$(PLUGIN)/$(PLUGIN).cmxs
+	mkdir -p plugins/$(PLUGIN)/cmxs/$(SYSTEM_NAME)
+	cp -f _build/default/plugins/$(PLUGIN)/$(PLUGIN).cmxs plugins/$(PLUGIN)/cmxs/$(SYSTEM_NAME)/plugin.cmxs
 
 kill_exe_win:
 ifdef SYSTEMROOT
 	-@taskkill /F /IM haxe.exe 2>/dev/null
-endif
-
-plugin:
-ifeq ($(BYTECODE),1)
-	$(CC_CMD) $(PLUGIN).ml
-else
-	$(COMPILER) $(ALL_CFLAGS) -shared -o $(PLUGIN).cmxs $(PLUGIN).ml
 endif
 
 # Only use if you have only changed gencpp.ml
@@ -188,6 +100,7 @@
 	cp $< $@
 endif
 
+# haxelib should depends on haxe, but we don't want to do that...
 haxelib:
 	(cd $(CURDIR)/extra/haxelib_src && $(CURDIR)/$(HAXE_OUTPUT) client.hxml && nekotools boot run.n)
 	mv extra/haxelib_src/run$(EXTENSION) $(HAXELIB_OUTPUT)
@@ -211,13 +124,15 @@
 	rm -rf $(DESTDIR)$(INSTALL_STD_DIR)
 
 opam_install:
-	opam install $(OPAM_LIBS) camlp5 ocamlfind --yes
-
-# Dependencies
-
--include Makefile.dependencies
+	opam install camlp5 ocamlfind dune --yes
+
+haxe_deps:
+	opam pin add haxe . --no-action
+	opam install haxe --deps-only --yes
 
 # Package
+
+package_env: opam_install haxe_deps
 
 package_src:
 	mkdir -p $(PACKAGE_OUT_DIR)
@@ -300,10 +215,7 @@
 
 # Clean
 
-clean: clean_libs clean_haxe clean_tools clean_package
-
-clean_libs:
-	$(foreach lib,$(EXTLIB_LIBS),$(MAKE) -C libs/$(lib) clean &&) true
+clean: clean_haxe clean_tools clean_package
 
 clean_haxe:
 	rm -f -r _build $(HAXE_OUTPUT) $(PREBUILD_OUTPUT)
@@ -324,4 +236,7 @@
 .ml.cmo:
 	$(CC_CMD)
 
-.PHONY: haxe libs haxelib
+.PHONY: haxe haxelib
+
+# our "all:" target doens't work in parallel mode
+.NOTPARALLEL:

=== libs/pcre/Makefile ===
ALL_CFLAGS = $(CFLAGS) -I pcre
LIBS =
OCAMLOPT=ocamlopt
OCAMLC=ocamlc
SRC = pcre.ml pcre_stubs.c

all: bytecode native

bytecode: pcre.cma

native: pcre.cmxa

pcre.cma: pcre_stubs.o pcre.ml
	$(OCAMLC) -safe-string -a -o pcre.cma $(LIBS) pcre.ml

pcre.cmxa: pcre.ml pcre_stubs.o
	$(OCAMLOPT) -safe-string -a -o pcre.cmxa $(LIBS) pcre.ml

pcre_stubs.o: pcre_stubs.c
	$(OCAMLC) -safe-string $(ALL_CFLAGS) pcre_stubs.c

clean:
	rm -f pcre.cma pcre.cmi pcre.cmx pcre.cmxa pcre.o pcre.obj pcre_stubs.obj pcre_stubs.o
	rm -f pcre.a libpcre.a libpcre.lib pcre.cmo

.PHONY: all bytecode native clean
Makefile: ;
$(SRC): ;

=== libs/ttflib/Makefile ===
OCAMLOPT=ocamlopt
OCAMLC=ocamlc

FLAGS=-package extlib -safe-string -I ../extlib-leftovers -I ../swflib
FILES=tTFData tTFParser tTFTools tTFSwfWriter tTFCanvasWriter tTFJsonWriter
LIBS=extLib swflib unix

OUTPUT=ttf

all: native bytecode

native: ttflib.cmxa

bytecode: ttflib.cma

ttflib.cmxa: $(FILES:=.ml)
	ocamlfind $(OCAMLOPT) $(FLAGS) $(FILES:=.ml) -g -a -o ttflib.cmxa

ttflib.cma: $(FILES:=.ml)
	ocamlfind $(OCAMLC) $(FLAGS) $(FILES:=.ml) -g -a -o ttflib.cma

exec:
	ocamlfind $(OCAMLOPT) $(FLAGS) $(LIBS:=.cmxa) $(FILES:=.ml) main.ml -g -o $(OUTPUT)

clean:
	rm -rf ttflib.cmxa ttflib.cma ttflib.lib ttflib.a $(wildcard *.cmx) $(wildcard *.obj) $(wildcard *.o) $(wildcard *.cmi) $(wildcard *.cmo)

.PHONY: all native bytecode clean exec

Makefile: ;
$(FILES:=.ml): ;

=== debian/changelog ===
haxe (1:4.1.5-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Tue, 05 Jan 2021 22:45:12 +0800

haxe (1:4.1.4-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sun, 20 Sep 2020 23:24:55 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Build-Depends: debhelper (>= 10),
                dh-ocaml,
                ocaml-nox,

=== debian/rules ===
--- 
+++ 
@@ -4,20 +4,10 @@
 include /usr/share/ocaml/ocamlvars.mk
 include /usr/share/dpkg/pkg-info.mk
 
-# bytecompile everything if ocamlopt doesn't exists
-ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
-	BYTECODE = "BYTECODE=1"
-endif
-
 %:
-	dh $@ --with ocaml,bash-completion
+	dh $@ --with ocaml,bash-completion --no-parallel
 
 override_dh_auto_configure:
-
-override_dh_auto_build:
-	dh_auto_build -- $(BYTECODE)
-	# Compile haxelib to neko
-	dh_auto_build -- tools
 
 override_dh_auto_install:

=== debian/tests/control ===
Tests: interp, haxelib
Depends: @

## haxe 4.2.4

=== Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 
 ADD_REVISION?=0
 
-BRANCH=$(shell echo $$APPVEYOR_REPO_NAME | grep -q /haxe && echo $$APPVEYOR_REPO_BRANCH || echo $$TRAVIS_REPO_SLUG | grep -q /haxe && echo $$TRAVIS_BRANCH || git rev-parse --abbrev-ref HEAD)
+BRANCH=$(shell git rev-parse --abbrev-ref HEAD)
 COMMIT_SHA=$(shell git rev-parse --short HEAD)
 COMMIT_DATE=$(shell \
 	if [ "$$(uname)" = "Darwin" ]; then \

=== tests/misc/cppObjc/native/Makefile ===
CC=clang

SOURCES=$(wildcard *.m)
OBJECTS=$(SOURCES:.m=.o)

libtest.a : $(OBJECTS)
	$(AR) rcs libtest.a $(OBJECTS)
	ranlib libtest.a

%.c.o : %.c $(C_DEPS)
	$(VERBOSE)$(CC) $(ALL_CFLAGS) -o $@ -c $<
	 
%.cpp.o : %.cpp $(C_DEPS)
	$(VERBOSE)$(CXX) $(CXXFLAGS) -o $@ -c $<
	 
%.m.o : %.m $(C_DEPS)
	$(VERBOSE)$(CXX) $(ALL_CFLAGS) -o $@ -c $<
	 
%.mm.o : %.mm $(C_DEPS)
	$(VERBOSE)$(CXX) $(CXXFLAGS) -o $@ -c $<

=== debian/changelog ===
haxe (1:4.2.4-1build1) jammy; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 18 Feb 2022 12:04:14 +0100

haxe (1:4.2.4-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sat, 27 Nov 2021 15:25:32 +0800

haxe (1:4.2.3-1) experimental; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sat, 03 Jul 2021 17:57:10 +0800

haxe (1:4.2.2-1) experimental; urgency=medium

  * New upstream version.
  * Update d/watch.

 -- Andy Li <andy@onthewings.net>  Mon, 07 Jun 2021 16:53:59 +0800

haxe (1:4.2.1-1) experimental; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sat, 27 Feb 2021 15:43:18 +0800

haxe (1:4.2.0-1) experimental; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Fri, 12 Feb 2021 12:57:25 +0800

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,8 @@
                libextlib-ocaml-dev,
                libptmap-ocaml-dev,
                libsha-ocaml-dev,
+               libluv-ocaml-dev (>= 0.5.6),
+               libuv1-dev,
                libmbedtls-dev,
                neko (>= 2.3.0),
                zlib1g-dev,

=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases/latest .*/archive/refs/tags/(\d\S*)\.tar\.gz

## haxe 4.2.5

=== libs/Makefile ===
OCAMLOPT = ocamlopt
OCAMLC = ocamlc
TARGET_FLAG = all
LIBS=extlib-leftovers extc neko javalib ilib swflib ttflib objsize pcre ziplib

all: $(LIBS)
$(LIBS):
	$(MAKE) -C $@ OCAMLOPT=$(OCAMLOPT) OCAMLC=$(OCAMLC) $(TARGET_FLAG)

clean:
	$(MAKE) -C extlib-leftovers clean
	$(MAKE) -C extc clean
	$(MAKE) -C neko clean
	$(MAKE) -C javalib clean
	$(MAKE) -C ilib clean
	$(MAKE) -C swflib clean
	$(MAKE) -C ttflib clean
	$(MAKE) -C objsize clean
	$(MAKE) -C pcre clean
	$(MAKE) -C ziplib clean

.PHONY: all clean $(LIBS)

Makefile: ;

=== debian/changelog ===
haxe (1:4.2.5-1) unstable; urgency=medium

  * New upstream version.
  * Update d/rules get-orig-source to use python3.
  * Update d/copyright about extlib(-leftovers) and xml-light (removed).
  * Update d/watch to version 4.
  * Bump Standards-Version to 4.6.1 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 05 Sep 2022 21:44:54 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Build-Depends: debhelper (>= 10),
                dh-ocaml,
                ocaml-nox,

=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/g" \
 https://github.com/HaxeFoundation/haxe/releases/latest .*/archive/refs/tags/(\d\S*)\.tar\.gz

## haxe 4.3.1

=== debian/changelog ===
haxe (1:4.3.1-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version to 4.6.2 (no changes).

 -- Andy Li <andy@onthewings.net>  Sun, 23 Jul 2023 11:08:36 +0000

## haxe 4.3.2

=== debian/changelog ===
haxe (1:4.3.2-1) unstable; urgency=medium

  * New upstream version.
  * Fix d/watch.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Andy Li <andy@onthewings.net>  Sat, 16 Sep 2023 11:00:21 +0000

## haxe 4.3.3

=== Makefile ===
--- 
+++ 
@@ -59,10 +59,14 @@
 HAXE_VERSION=$(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1 | awk '{print $$1;}')
 HAXE_VERSION_SHORT=$(shell echo "$(HAXE_VERSION)" | grep -oE "^[0-9]+\.[0-9]+\.[0-9]+")
 
+NEKO_VERSION=2.3.0
+NEKO_MAJOR_VERSION=$(shell echo "$(NEKO_VERSION)" | grep -oE "^[0-9]+")
+NEKO_VERSION_TAG=v$(shell echo "$(NEKO_VERSION)" | sed "s/\./-/g")
+
 ifneq ($(STATICLINK),0)
-	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre -lz -lmbedtls -lmbedx509 -lmbedcrypto -Wl,-Bdynamic '
+	LIB_PARAMS= -cclib '-Wl,-Bstatic -lpcre2-8 -lz -lmbedtls -lmbedx509 -lmbedcrypto -Wl,-Bdynamic '
 else
-	LIB_PARAMS?= -cclib -lpcre -cclib -lz -cclib -lmbedtls -cclib -lmbedx509 -cclib -lmbedcrypto
+	LIB_PARAMS?= -cclib -lpcre2-8 -cclib -lz -cclib -lmbedtls -cclib -lmbedx509 -cclib -lmbedcrypto
 endif
 ifeq ($(SYSTEM_NAME),Mac)
 	LIB_PARAMS+= -cclib '-framework Security -framework CoreFoundation'
@@ -165,7 +169,7 @@
 	mkdir -p $(INSTALLER_TMP_DIR)
 
 $(INSTALLER_TMP_DIR)/neko-osx64.tar.gz: $(INSTALLER_TMP_DIR)
-	wget -nv https://github.com/HaxeFoundation/neko/releases/download/v2-3-0/neko-2.3.0-osx64.tar.gz -O installer/neko-osx64.tar.gz
+	wget -nv https://github.com/HaxeFoundation/neko/releases/download/$(NEKO_VERSION_TAG)/neko-$(NEKO_VERSION)-osx64.tar.gz -O installer/neko-osx64.tar.gz
 
 # Installer
 
@@ -173,7 +177,6 @@
 	$(eval OUTFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_installer.tar.gz)
 	$(eval PACKFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz)
 	$(eval VERSION := $(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1))
-	$(eval NEKOVER := $(shell neko -version 2>&1))
 	bash -c "rm -rf $(INSTALLER_TMP_DIR)/{resources,pkg,tgz,haxe.tar.gz}"
 	mkdir $(INSTALLER_TMP_DIR)/resources
 	# neko - unpack to change the dir name
@@ -186,6 +189,8 @@
 	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf haxe.tar.gz haxe
 	# scripts
 	cp -rf extra/mac-installer/* $(INSTALLER_TMP_DIR)/resources
+	sed -i '' 's/%%NEKO_VERSION%%/$(NEKO_VERSION)/g' $(INSTALLER_TMP_DIR)/resources/scripts/neko-postinstall.sh
+	sed -i '' 's/%%NEKO_MAJOR_VERSION%%/$(NEKO_MAJOR_VERSION)/g' $(INSTALLER_TMP_DIR)/resources/scripts/neko-postinstall.sh
 	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf scripts.tar.gz scripts
 	# installer structure
 	mkdir -p $(INSTALLER_TMP_DIR)/pkg
@@ -201,12 +206,12 @@
 	sed -i '' 's/%%VERSION%%/$(VERSION)/g' PackageInfo ;\
 	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' PackageInfo ;\
 	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' PackageInfo ;\
-	sed -i '' 's/%%NEKOVER%%/$(NEKOVER)/g' PackageInfo ;\
+	sed -i '' 's/%%NEKOVER%%/$(NEKO_VERSION)/g' PackageInfo ;\
 	cd .. ;\
 	sed -i '' 's/%%VERSION%%/$(VERSION)/g' Distribution ;\
 	sed -i '' 's/%%VERSTRING%%/$(VERSION)/g' Distribution ;\
 	sed -i '' 's/%%VERLONG%%/$(VERSION)/g' Distribution ;\
-	sed -i '' 's/%%NEKOVER%%/$(NEKOVER)/g' Distribution ;\
+	sed -i '' 's/%%NEKOVER%%/$(NEKO_VERSION)/g' Distribution ;\
 	sed -i '' 's/%%INSTKB%%/$$INSTKBH/g' Distribution"
 	# repackage
 	cd $(INSTALLER_TMP_DIR)/pkg; xar --compression none -cf ../$(PACKAGE_FILE_NAME).pkg *

=== debian/changelog ===
haxe (1:4.3.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:56:16 +1100

haxe (1:4.3.3-1build1) noble; urgency=medium

  * No-change rebuild against libuv1 t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 19:44:54 +0100

haxe (1:4.3.3-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Sat, 18 Nov 2023 14:20:38 +0000

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,26 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.6.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
+Standards-Version: 4.6.2
 Build-Depends: debhelper (>= 10),
                dh-ocaml,
                ocaml-nox,
                ocaml-findlib,
-               ocaml-dune,
+               ocaml-dune (>= 3),
                camlp5,
                libxml-light-ocaml-dev,
                libsedlex-ocaml-dev (>= 2.0),
                libextlib-ocaml-dev,
                libptmap-ocaml-dev,
                libsha-ocaml-dev,
-               libluv-ocaml-dev (>= 0.5.6),
+               libluv-ocaml-dev (>= 0.5.12),
                libuv1-dev,
                libmbedtls-dev,
                neko (>= 2.3.0),
                zlib1g-dev,
-               libpcre3-dev,
+               libpcre2-dev,
                bash-completion
 Vcs-Git: https://github.com/HaxeFoundation/haxe-debian.git
 Vcs-Browser: https://github.com/HaxeFoundation/haxe-debian

=== debian/rules ===
--- 
+++ 
@@ -22,5 +22,5 @@
 	# create tar manually from git, in order to get submodules
 	git clone --branch $(DEB_VERSION_UPSTREAM) --depth 1 --recursive https://github.com/HaxeFoundation/haxe.git orig-source
 	cd orig-source && \
-		python $(CURDIR)/debian/git-archive-all ../../haxe_$(DEB_VERSION_UPSTREAM).orig.tar.gz
+		python3 $(CURDIR)/debian/git-archive-all ../../haxe_$(DEB_VERSION_UPSTREAM).orig.tar.gz
 	rm -rf orig-source

## haxe 4.3.4

=== debian/changelog ===
haxe (1:4.3.4-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Fri, 22 Mar 2024 17:30:43 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
+Maintainer: Andy Li <andy@onthewings.net>
 Standards-Version: 4.6.2
 Build-Depends: debhelper (>= 10),
                dh-ocaml,

## haxe 4.3.6

=== Makefile ===
--- 
+++ 
@@ -59,7 +59,7 @@
 HAXE_VERSION=$(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1 | awk '{print $$1;}')
 HAXE_VERSION_SHORT=$(shell echo "$(HAXE_VERSION)" | grep -oE "^[0-9]+\.[0-9]+\.[0-9]+")
 
-NEKO_VERSION=2.3.0
+NEKO_VERSION=2.4.0
 NEKO_MAJOR_VERSION=$(shell echo "$(NEKO_VERSION)" | grep -oE "^[0-9]+")
 NEKO_VERSION_TAG=v$(shell echo "$(NEKO_VERSION)" | sed "s/\./-/g")
 
@@ -104,10 +104,24 @@
 	cp $< $@
 endif
 
+ifeq ($(SYSTEM_NAME),Mac)
+# This assumes that haxelib and neko will both be installed into INSTALL_DIR,
+# which is the case when installing using the mac installer package
+HAXELIB_LFLAGS= -Wl,-rpath,$(INSTALL_DIR)/lib
+endif
+
+haxelib_unix:
+	cd $(CURDIR)/extra/haxelib_src && \
+	HAXE_STD_PATH=$(CURDIR)/std $(CURDIR)/$(HAXE_OUTPUT) client.hxml && \
+	nekotools boot -c run.n
+	$(CC) $(CURDIR)/extra/haxelib_src/run.c -o $(HAXELIB_OUTPUT) -lneko $(HAXELIB_LFLAGS)
+
 # haxelib should depends on haxe, but we don't want to do that...
-haxelib:
-	(cd $(CURDIR)/extra/haxelib_src && $(CURDIR)/$(HAXE_OUTPUT) client.hxml && nekotools boot run.n)
-	mv extra/haxelib_src/run$(EXTENSION) $(HAXELIB_OUTPUT)
+ifeq ($(SYSTEM_NAME),Windows)
+haxelib: haxelib_$(PLATFORM)
+else
+haxelib: haxelib_unix
+endif
 
 tools: haxelib
 
@@ -168,19 +182,29 @@
 $(INSTALLER_TMP_DIR):
 	mkdir -p $(INSTALLER_TMP_DIR)
 
-$(INSTALLER_TMP_DIR)/neko-osx64.tar.gz: $(INSTALLER_TMP_DIR)
-	wget -nv https://github.com/HaxeFoundation/neko/releases/download/$(NEKO_VERSION_TAG)/neko-$(NEKO_VERSION)-osx64.tar.gz -O installer/neko-osx64.tar.gz
+# Can be 'universal', 'arm64', or 'x86_64'
+ifndef PACKAGE_INSTALLER_MAC_ARCH
+PACKAGE_INSTALLER_MAC_ARCH:=$(shell uname -m)
+endif
+
+$(INSTALLER_TMP_DIR)/neko-osx.tar.gz: $(INSTALLER_TMP_DIR)
+	NEKO_ARCH_SUFFIX=$$(if [ "$(PACKAGE_INSTALLER_MAC_ARCH)" = "x86_64" ]; then \
+		echo 64; \
+	else \
+		echo "-$(PACKAGE_INSTALLER_MAC_ARCH)"; \
+	fi); \
+	wget -nv https://github.com/HaxeFoundation/neko/releases/download/$(NEKO_VERSION_TAG)/neko-$(NEKO_VERSION)-osx$$NEKO_ARCH_SUFFIX.tar.gz -O installer/neko-osx.tar.gz
 
 # Installer
 
-package_installer_mac: $(INSTALLER_TMP_DIR)/neko-osx64.tar.gz package_unix
+package_installer_mac: $(INSTALLER_TMP_DIR)/neko-osx.tar.gz package_unix
 	$(eval OUTFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_installer.tar.gz)
 	$(eval PACKFILE := $(shell pwd)/$(PACKAGE_OUT_DIR)/$(PACKAGE_FILE_NAME)_bin.tar.gz)
 	$(eval VERSION := $(shell $(CURDIR)/$(HAXE_OUTPUT) -version 2>&1))
 	bash -c "rm -rf $(INSTALLER_TMP_DIR)/{resources,pkg,tgz,haxe.tar.gz}"
 	mkdir $(INSTALLER_TMP_DIR)/resources
 	# neko - unpack to change the dir name
-	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf ../neko-osx64.tar.gz
+	cd $(INSTALLER_TMP_DIR)/resources && tar -zxvf ../neko-osx.tar.gz
 	mv $(INSTALLER_TMP_DIR)/resources/neko* $(INSTALLER_TMP_DIR)/resources/neko
 	cd $(INSTALLER_TMP_DIR)/resources && tar -zcvf neko.tar.gz neko
 	# haxe - unpack to change the dir name

=== debian/changelog ===
haxe (1:4.3.6-3) unstable; urgency=medium

  * Fix changelog of 1:4.3.6-2. (Closes: #1082569, #1093103)

 -- Andy Li <andy@onthewings.net>  Sun, 09 Feb 2025 21:36:28 +0000

haxe (1:4.3.6-2) unstable; urgency=medium

  * Add ocaml5.3.patch for compatibility with OCaml 5.3.
    (Closes: #1082569, #1093103)

 -- Andy Li <andy@onthewings.net>  Sun, 09 Feb 2025 01:46:34 +0000

haxe (1:4.3.6-1) unstable; urgency=medium

  * New upstream version.
  * Add makefile-haxelib.patch to build haxelib with proper flags.
  * Strip haxelib, which is now a proper binary.
  * Bump Standards-Version to 4.7.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Sun, 18 Aug 2024 05:59:19 +0100

haxe (1:4.3.4-2) unstable; urgency=medium

  * Add mbedtls3.patch from upstream (Closes: #1075827).

 -- Andy Li <andy@onthewings.net>  Sat, 06 Jul 2024 08:52:59 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper (>= 10),
                dh-ocaml,
                ocaml-nox,
@@ -18,6 +18,7 @@
                libuv1-dev,
                libmbedtls-dev,
                neko (>= 2.3.0),
+               neko-dev (>= 2.3.0),
                zlib1g-dev,
                libpcre2-dev,
                bash-completion

=== debian/rules ===
--- 
+++ 
@@ -11,10 +11,6 @@
 
 override_dh_auto_install:
 
-override_dh_strip:
-	# haxelib is the neko vm appended with neko bytecode. It should not be stripped
-	dh_strip --exclude=haxelib
-
 override_dh_missing:
 	dh_missing --fail-missing
